Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- Debugging
- Interface
- Lit
- Logic
- MatchAnalysis
- MatchApproximation
- MatchCodeGen
- MatchCps
- MatchOptimization
- MatchTranslation
- MatchTreeMaking
- MatchWarnings
- PatternExpansion
- PatternMatching
- PatternMatchingStats
- ScalaLogic
- Solving
- TreeAndTypeAnalysis

t

scala.tools.nsc.transform.patmat

# MatchApproximation

###

#### trait MatchApproximation extends TreeAndTypeAnalysis with ScalaLogic with MatchTreeMaking

Source
  MatchAnalysis.scala

Linear Supertypes
MatchTreeMaking, MatchCodeGen, ScalaLogic, Logic, Interface, TreeDSL, TreeAndTypeAnalysis, Debugging, AnyRef, Any
Known Subclasses
patmat, MatchAnalysis, MatchOptimization, PatternMatching
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. MatchApproximation
2. MatchTreeMaking
3. MatchCodeGen
4. ScalaLogic
5. Logic
6. Interface
7. TreeDSL
8. TreeAndTypeAnalysis
9. Debugging
10. AnyRef
11. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Type Members

1.  trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

   Definition Classes
     Interface
2.  trait TypedSubstitution extends MatchMonadInterface
   Definition Classes
     Interface
3.  trait PropositionalLogic extends AnyRef
   Definition Classes
     Logic
4.  trait MatchApproximator extends TreeMakers with TreesAndTypesDomain

   Represent a match as a formula in propositional logic that encodes whether the match matches (abstractly: we only consider types)

5.  trait CodegenCore extends MatchMonadInterface
   Definition Classes
     MatchCodeGen
6.  trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface
   Definition Classes
     MatchCodeGen
7.  final case class Suppression(suppressExhaustive: Boolean, suppressUnreachable: Boolean) extends Product with Serializable
   Definition Classes
     MatchTreeMaking
8.  trait TreeMakers extends TypedSubstitution with CodegenCore
   Definition Classes
     MatchTreeMaking
9.  trait TreesAndTypesDomain extends PropositionalLogic with CheckableTreeAndTypeAnalysis
   Definition Classes
     ScalaLogic
10.  trait CheckableTreeAndTypeAnalysis extends AnyRef
    Definition Classes
      TreeAndTypeAnalysis

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     TreeDSL

### Concrete Value Members

1.  object CODE
   Definition Classes
     TreeDSL
2.  object debug
   Definition Classes
     Debugging
3.  object vpmName
   Definition Classes
     Interface
4.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
5.  final def ##: Int
   Definition Classes
     AnyRef → Any
6.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from MatchApproximation toany2stringadd[MatchApproximation] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
7.  def ->[B](y: B): (MatchApproximation, B)
   Implicit
     This member is added by an implicit conversion from MatchApproximation toArrowAssoc[MatchApproximation] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
8.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
9.  def alignAcrossRows(xss: List[List[Any]], sep: String, lineSep: String = "\n"): String
   Definition Classes
     Logic
10.  final def asInstanceOf[T0]: T0
    Definition Classes
      Any
11.  def binderTypeImpliedByPattern(pat: Global.Tree, pt: Global.Type): Global.Type

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Compute the type T implied for a value `v` matched by a pattern `pat` (with expected type `pt`).

    Usually, this is the pattern's type because pattern matching implies instance-of checks.

    However, Stable Identifier and Literal patterns are matched using `==`, which does not imply a type for the binder that binds the matched value. E.g., in `case x@Nil => x` , all we know about `x` is that it satisfies `Nil == x`, which could be anything. A type pattern with a literal type works the same as the corresponding literal pattern. A literal pattern with a Boolean or Unit pattern does enforce that the respective value (`true`, `false`, `()`) was matched, so in those cases, the pattern type is assumed.

    The other patterns imply type tests, so we can safely deduce that the binder has the pattern's type when the pattern matches. Concretely, a literal, type pattern, a case class (the constructor's result type) or extractor (the unapply's argument type) all imply type tests.

    See scala/bug#1503, scala/bug#5024: don't cast binders to types we're not sure they have

    Definition Classes
      TreeAndTypeAnalysis
12.  def clone(): AnyRef
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.CloneNotSupportedException]) @native()
13.  final def dealiasWiden(tp: Global.Type): Global.Type
    Attributes
      protected
    Definition Classes
      Interface
14.  def ensuring(cond: (MatchApproximation) => Boolean, msg: => Any): MatchApproximation
    Implicit
      This member is added by an implicit conversion from MatchApproximation toEnsuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (MatchApproximation) => Boolean): MatchApproximation
    Implicit
      This member is added by an implicit conversion from MatchApproximation toEnsuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: => Any): MatchApproximation
    Implicit
      This member is added by an implicit conversion from MatchApproximation toEnsuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): MatchApproximation
    Implicit
      This member is added by an implicit conversion from MatchApproximation toEnsuring[MatchApproximation] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
20.  def equivalentTree(a: Global.Tree, b: Global.Tree): Boolean
    Definition Classes
      TreeAndTypeAnalysis
21.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
22.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from MatchApproximation toStringFormat[MatchApproximation] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
23.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
24.  final def hasStableSymbol(p: Global.Tree): Boolean
    Attributes
      protected
    Definition Classes
      Interface
25.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
26.  def instanceOfTpImplies(tp: Global.Type, tpImplied: Global.Type): Boolean
    Definition Classes
      TreeAndTypeAnalysis
27.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
28.  final def mkFALSE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
29.  final def mkTRUE: Global.Literal
    Attributes
      protected
    Definition Classes
      Interface
30.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
31.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
32.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
33.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()
38.  object Suppression extends java.io.Serializable
    Definition Classes
      MatchTreeMaking

### Deprecated Value Members

1.  def →[B](y: B): (MatchApproximation, B)
   Implicit
     This member is added by an implicit conversion from MatchApproximation toArrowAssoc[MatchApproximation] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from MatchTreeMaking

### Inherited from MatchCodeGen

### Inherited from ScalaLogic

### Inherited from Logic

### Inherited from Interface

### Inherited from TreeDSL

### Inherited from TreeAndTypeAnalysis

### Inherited from Debugging

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromMatchApproximation to any2stringadd[MatchApproximation]

### Inherited by implicit conversion StringFormat fromMatchApproximation to StringFormat[MatchApproximation]

### Inherited by implicit conversion Ensuring fromMatchApproximation to Ensuring[MatchApproximation]

### Inherited by implicit conversion ArrowAssoc fromMatchApproximation to ArrowAssoc[MatchApproximation]

### Ungrouped